<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;humantime-2.1.0&#x2F;src&#x2F;duration.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>duration.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../humantime/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::error::Error</span> <span class="kw">as</span> <span class="ident">StdError</span>;
<span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::str::Chars</span>;
<span class="kw">use</span> <span class="ident">std::time::Duration</span>;

<span class="doccomment">/// Error parsing human-friendly duration</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Error</span> {
    <span class="doccomment">/// Invalid character during parsing</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// More specifically anything that is not alphanumeric is prohibited</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The field is an byte offset of the character in the string.</span>
    <span class="ident">InvalidCharacter</span>(<span class="ident">usize</span>),
    <span class="doccomment">/// Non-numeric value where number is expected</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This usually means that either time unit is broken into words,</span>
    <span class="doccomment">/// e.g. `m sec` instead of `msec`, or just number is omitted,</span>
    <span class="doccomment">/// for example `2 hours min` instead of `2 hours 1 min`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The field is an byte offset of the errorneous character</span>
    <span class="doccomment">/// in the string.</span>
    <span class="ident">NumberExpected</span>(<span class="ident">usize</span>),
    <span class="doccomment">/// Unit in the number is not one of allowed units</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// See documentation of `parse_duration` for the list of supported</span>
    <span class="doccomment">/// time units.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The two fields are start and end (exclusive) of the slice from</span>
    <span class="doccomment">/// the original string, containing errorneous value</span>
    <span class="ident">UnknownUnit</span> {
        <span class="doccomment">/// Start of the invalid unit inside the original string</span>
        <span class="ident">start</span>: <span class="ident">usize</span>,
        <span class="doccomment">/// End of the invalid unit inside the original string</span>
        <span class="ident">end</span>: <span class="ident">usize</span>,
        <span class="doccomment">/// The unit verbatim</span>
        <span class="ident">unit</span>: <span class="ident">String</span>,
        <span class="doccomment">/// A number associated with the unit</span>
        <span class="ident">value</span>: <span class="ident">u64</span>,
    },
    <span class="doccomment">/// The numeric value is too large</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Usually this means value is too large to be useful. If user writes</span>
    <span class="doccomment">/// data in subsecond units, then the maximum is about 3k years. When</span>
    <span class="doccomment">/// using seconds, or larger units, the limit is even larger.</span>
    <span class="ident">NumberOverflow</span>,
    <span class="doccomment">/// The value was an empty string (or consists only whitespace)</span>
    <span class="ident">Empty</span>,
}

<span class="kw">impl</span> <span class="ident">StdError</span> <span class="kw">for</span> <span class="ident">Error</span> {}

<span class="kw">impl</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Error::InvalidCharacter</span>(<span class="ident">offset</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;invalid character at {}&quot;</span>, <span class="ident">offset</span>),
            <span class="ident">Error::NumberExpected</span>(<span class="ident">offset</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;expected number at {}&quot;</span>, <span class="ident">offset</span>),
            <span class="ident">Error::UnknownUnit</span> { <span class="ident">unit</span>, <span class="ident">value</span>, .. } <span class="kw">if</span> <span class="kw-2">&amp;</span><span class="ident">unit</span> <span class="op">=</span><span class="op">=</span> <span class="kw-2">&amp;</span><span class="string">&quot;&quot;</span> <span class="op">=</span><span class="op">&gt;</span> {
                <span class="macro">write!</span>(<span class="ident">f</span>,
                    <span class="string">&quot;time unit needed, for example {0}sec or {0}ms&quot;</span>,
                    <span class="ident">value</span>,
                )
            }
            <span class="ident">Error::UnknownUnit</span> { <span class="ident">unit</span>, .. } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="macro">write!</span>(
                    <span class="ident">f</span>,
                    <span class="string">&quot;unknown time unit {:?}, \
                    supported units: ns, us, ms, sec, min, hours, days, \
                    weeks, months, years (and few variations)&quot;</span>,
                    <span class="ident">unit</span>
                )
            }
            <span class="ident">Error::NumberOverflow</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;number is too large&quot;</span>),
            <span class="ident">Error::Empty</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;value was empty&quot;</span>),
        }
    }
}

<span class="doccomment">/// A wrapper type that allows you to Display a Duration</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">FormattedDuration</span>(<span class="ident">Duration</span>);

<span class="kw">trait</span> <span class="ident">OverflowOp</span>: <span class="ident">Sized</span> {
    <span class="kw">fn</span> <span class="ident">mul</span>(<span class="self">self</span>, <span class="ident">other</span>: <span class="self">Self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">Error</span><span class="op">&gt;</span>;
    <span class="kw">fn</span> <span class="ident">add</span>(<span class="self">self</span>, <span class="ident">other</span>: <span class="self">Self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">Error</span><span class="op">&gt;</span>;
}

<span class="kw">impl</span> <span class="ident">OverflowOp</span> <span class="kw">for</span> <span class="ident">u64</span> {
    <span class="kw">fn</span> <span class="ident">mul</span>(<span class="self">self</span>, <span class="ident">other</span>: <span class="self">Self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">checked_mul</span>(<span class="ident">other</span>).<span class="ident">ok_or</span>(<span class="ident">Error::NumberOverflow</span>)
    }
    <span class="kw">fn</span> <span class="ident">add</span>(<span class="self">self</span>, <span class="ident">other</span>: <span class="self">Self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">checked_add</span>(<span class="ident">other</span>).<span class="ident">ok_or</span>(<span class="ident">Error::NumberOverflow</span>)
    }
}

<span class="kw">struct</span> <span class="ident">Parser</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">iter</span>: <span class="ident">Chars</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>,
    <span class="ident">src</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
    <span class="ident">current</span>: (<span class="ident">u64</span>, <span class="ident">u64</span>),
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Parser</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">off</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">src</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="self">self</span>.<span class="ident">iter</span>.<span class="ident">as_str</span>().<span class="ident">len</span>()
    }

    <span class="kw">fn</span> <span class="ident">parse_first_char</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">off</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">off</span>();
        <span class="kw">for</span> <span class="ident">c</span> <span class="kw">in</span> <span class="self">self</span>.<span class="ident">iter</span>.<span class="ident">by_ref</span>() {
            <span class="kw">match</span> <span class="ident">c</span> {
                <span class="string">&#39;0&#39;</span>..<span class="op">=</span><span class="string">&#39;9&#39;</span> <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="ident">c</span> <span class="kw">as</span> <span class="ident">u64</span> <span class="op">-</span> <span class="string">&#39;0&#39;</span> <span class="kw">as</span> <span class="ident">u64</span>));
                }
                <span class="ident">c</span> <span class="kw">if</span> <span class="ident">c</span>.<span class="ident">is_whitespace</span>() <span class="op">=</span><span class="op">&gt;</span> <span class="kw">continue</span>,
                <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::NumberExpected</span>(<span class="ident">off</span>));
                }
            }
        }
        <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
    }
    <span class="kw">fn</span> <span class="ident">parse_unit</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">n</span>: <span class="ident">u64</span>, <span class="ident">start</span>: <span class="ident">usize</span>, <span class="ident">end</span>: <span class="ident">usize</span>)
        <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span>
    {
        <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">sec</span>, <span class="ident">nsec</span>) <span class="op">=</span> <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">src</span>[<span class="ident">start</span>..<span class="ident">end</span>] {
            <span class="string">&quot;nanos&quot;</span> <span class="op">|</span> <span class="string">&quot;nsec&quot;</span> <span class="op">|</span> <span class="string">&quot;ns&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="number">0u64</span>, <span class="ident">n</span>),
            <span class="string">&quot;usec&quot;</span> <span class="op">|</span> <span class="string">&quot;us&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="number">0u64</span>, <span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">1000</span>)<span class="question-mark">?</span>),
            <span class="string">&quot;millis&quot;</span> <span class="op">|</span> <span class="string">&quot;msec&quot;</span> <span class="op">|</span> <span class="string">&quot;ms&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="number">0u64</span>, <span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">1_000_000</span>)<span class="question-mark">?</span>),
            <span class="string">&quot;seconds&quot;</span> <span class="op">|</span> <span class="string">&quot;second&quot;</span> <span class="op">|</span> <span class="string">&quot;secs&quot;</span> <span class="op">|</span> <span class="string">&quot;sec&quot;</span> <span class="op">|</span> <span class="string">&quot;s&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">n</span>, <span class="number">0</span>),
            <span class="string">&quot;minutes&quot;</span> <span class="op">|</span> <span class="string">&quot;minute&quot;</span> <span class="op">|</span> <span class="string">&quot;min&quot;</span> <span class="op">|</span> <span class="string">&quot;mins&quot;</span> <span class="op">|</span> <span class="string">&quot;m&quot;</span>
            <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">60</span>)<span class="question-mark">?</span>, <span class="number">0</span>),
            <span class="string">&quot;hours&quot;</span> <span class="op">|</span> <span class="string">&quot;hour&quot;</span> <span class="op">|</span> <span class="string">&quot;hr&quot;</span> <span class="op">|</span> <span class="string">&quot;hrs&quot;</span> <span class="op">|</span> <span class="string">&quot;h&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">3600</span>)<span class="question-mark">?</span>, <span class="number">0</span>),
            <span class="string">&quot;days&quot;</span> <span class="op">|</span> <span class="string">&quot;day&quot;</span> <span class="op">|</span> <span class="string">&quot;d&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">86400</span>)<span class="question-mark">?</span>, <span class="number">0</span>),
            <span class="string">&quot;weeks&quot;</span> <span class="op">|</span> <span class="string">&quot;week&quot;</span> <span class="op">|</span> <span class="string">&quot;w&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">86400</span><span class="kw-2">*</span><span class="number">7</span>)<span class="question-mark">?</span>, <span class="number">0</span>),
            <span class="string">&quot;months&quot;</span> <span class="op">|</span> <span class="string">&quot;month&quot;</span> <span class="op">|</span> <span class="string">&quot;M&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">2_630_016</span>)<span class="question-mark">?</span>, <span class="number">0</span>), <span class="comment">// 30.44d</span>
            <span class="string">&quot;years&quot;</span> <span class="op">|</span> <span class="string">&quot;year&quot;</span> <span class="op">|</span> <span class="string">&quot;y&quot;</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">n</span>.<span class="ident">mul</span>(<span class="number">31_557_600</span>)<span class="question-mark">?</span>, <span class="number">0</span>), <span class="comment">// 365.25d</span>
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::UnknownUnit</span> {
                    <span class="ident">start</span>, <span class="ident">end</span>,
                    <span class="ident">unit</span>: <span class="self">self</span>.<span class="ident">src</span>[<span class="ident">start</span>..<span class="ident">end</span>].<span class="ident">to_string</span>(),
                    <span class="ident">value</span>: <span class="ident">n</span>,
                });
            }
        };
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">nsec</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">current</span>.<span class="number">1</span>.<span class="ident">add</span>(<span class="ident">nsec</span>)<span class="question-mark">?</span>;
        <span class="kw">if</span> <span class="ident">nsec</span> <span class="op">&gt;</span> <span class="number">1_000_000_000</span> {
            <span class="ident">sec</span> <span class="op">=</span> <span class="ident">sec</span>.<span class="ident">add</span>(<span class="ident">nsec</span> <span class="op">/</span> <span class="number">1_000_000_000</span>)<span class="question-mark">?</span>;
            <span class="ident">nsec</span> <span class="op">%</span><span class="op">=</span> <span class="number">1_000_000_000</span>;
        }
        <span class="ident">sec</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">current</span>.<span class="number">0</span>.<span class="ident">add</span>(<span class="ident">sec</span>)<span class="question-mark">?</span>;
        <span class="self">self</span>.<span class="ident">current</span> <span class="op">=</span> (<span class="ident">sec</span>, <span class="ident">nsec</span>);
        <span class="prelude-val">Ok</span>(())
    }

    <span class="kw">fn</span> <span class="ident">parse</span>(<span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Duration</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">n</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">parse_first_char</span>()<span class="question-mark">?</span>.<span class="ident">ok_or</span>(<span class="ident">Error::Empty</span>)<span class="question-mark">?</span>;
        <span class="lifetime">&#39;outer</span>: <span class="kw">loop</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">off</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">off</span>();
            <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">c</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">iter</span>.<span class="ident">next</span>() {
                <span class="kw">match</span> <span class="ident">c</span> {
                    <span class="string">&#39;0&#39;</span>..<span class="op">=</span><span class="string">&#39;9&#39;</span> <span class="op">=</span><span class="op">&gt;</span> {
                        <span class="ident">n</span> <span class="op">=</span> <span class="ident">n</span>.<span class="ident">checked_mul</span>(<span class="number">10</span>)
                            .<span class="ident">and_then</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span>.<span class="ident">checked_add</span>(<span class="ident">c</span> <span class="kw">as</span> <span class="ident">u64</span> <span class="op">-</span> <span class="string">&#39;0&#39;</span> <span class="kw">as</span> <span class="ident">u64</span>))
                            .<span class="ident">ok_or</span>(<span class="ident">Error::NumberOverflow</span>)<span class="question-mark">?</span>;
                    }
                    <span class="ident">c</span> <span class="kw">if</span> <span class="ident">c</span>.<span class="ident">is_whitespace</span>() <span class="op">=</span><span class="op">&gt;</span> {}
                    <span class="string">&#39;a&#39;</span>..<span class="op">=</span><span class="string">&#39;z&#39;</span> <span class="op">|</span> <span class="string">&#39;A&#39;</span>..<span class="op">=</span><span class="string">&#39;Z&#39;</span> <span class="op">=</span><span class="op">&gt;</span> {
                        <span class="kw">break</span>;
                    }
                    <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> {
                        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::InvalidCharacter</span>(<span class="ident">off</span>));
                    }
                }
                <span class="ident">off</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">off</span>();
            }
            <span class="kw">let</span> <span class="ident">start</span> <span class="op">=</span> <span class="ident">off</span>;
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">off</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">off</span>();
            <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">c</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">iter</span>.<span class="ident">next</span>() {
                <span class="kw">match</span> <span class="ident">c</span> {
                    <span class="string">&#39;0&#39;</span>..<span class="op">=</span><span class="string">&#39;9&#39;</span> <span class="op">=</span><span class="op">&gt;</span> {
                        <span class="self">self</span>.<span class="ident">parse_unit</span>(<span class="ident">n</span>, <span class="ident">start</span>, <span class="ident">off</span>)<span class="question-mark">?</span>;
                        <span class="ident">n</span> <span class="op">=</span> <span class="ident">c</span> <span class="kw">as</span> <span class="ident">u64</span> <span class="op">-</span> <span class="string">&#39;0&#39;</span> <span class="kw">as</span> <span class="ident">u64</span>;
                        <span class="kw">continue</span> <span class="lifetime">&#39;outer</span>;
                    }
                    <span class="ident">c</span> <span class="kw">if</span> <span class="ident">c</span>.<span class="ident">is_whitespace</span>() <span class="op">=</span><span class="op">&gt;</span> <span class="kw">break</span>,
                    <span class="string">&#39;a&#39;</span>..<span class="op">=</span><span class="string">&#39;z&#39;</span> <span class="op">|</span> <span class="string">&#39;A&#39;</span>..<span class="op">=</span><span class="string">&#39;Z&#39;</span> <span class="op">=</span><span class="op">&gt;</span> {}
                    <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> {
                        <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">Error::InvalidCharacter</span>(<span class="ident">off</span>));
                    }
                }
                <span class="ident">off</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">off</span>();
            }
            <span class="self">self</span>.<span class="ident">parse_unit</span>(<span class="ident">n</span>, <span class="ident">start</span>, <span class="ident">off</span>)<span class="question-mark">?</span>;
            <span class="ident">n</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">parse_first_char</span>()<span class="question-mark">?</span> {
                <span class="prelude-val">Some</span>(<span class="ident">n</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">n</span>,
                <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="prelude-val">Ok</span>(
                    <span class="ident">Duration::new</span>(<span class="self">self</span>.<span class="ident">current</span>.<span class="number">0</span>, <span class="self">self</span>.<span class="ident">current</span>.<span class="number">1</span> <span class="kw">as</span> <span class="ident">u32</span>)),
            };
        }
    }

}

<span class="doccomment">/// Parse duration object `1hour 12min 5s`</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The duration object is a concatenation of time spans. Where each time</span>
<span class="doccomment">/// span is an integer number and a suffix. Supported suffixes:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// * `nsec`, `ns` -- nanoseconds</span>
<span class="doccomment">/// * `usec`, `us` -- microseconds</span>
<span class="doccomment">/// * `msec`, `ms` -- milliseconds</span>
<span class="doccomment">/// * `seconds`, `second`, `sec`, `s`</span>
<span class="doccomment">/// * `minutes`, `minute`, `min`, `m`</span>
<span class="doccomment">/// * `hours`, `hour`, `hr`, `h`</span>
<span class="doccomment">/// * `days`, `day`, `d`</span>
<span class="doccomment">/// * `weeks`, `week`, `w`</span>
<span class="doccomment">/// * `months`, `month`, `M` -- defined as 30.44 days</span>
<span class="doccomment">/// * `years`, `year`, `y` -- defined as 365.25 days</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use std::time::Duration;</span>
<span class="doccomment">/// use humantime::parse_duration;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(parse_duration(&quot;2h 37min&quot;), Ok(Duration::new(9420, 0)));</span>
<span class="doccomment">/// assert_eq!(parse_duration(&quot;32ms&quot;), Ok(Duration::new(0, 32_000_000)));</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse_duration</span>(<span class="ident">s</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Duration</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="ident">Parser</span> {
        <span class="ident">iter</span>: <span class="ident">s</span>.<span class="ident">chars</span>(),
        <span class="ident">src</span>: <span class="ident">s</span>,
        <span class="ident">current</span>: (<span class="number">0</span>, <span class="number">0</span>),
    }.<span class="ident">parse</span>()
}

<span class="doccomment">/// Formats duration into a human-readable string</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note: this format is guaranteed to have same value when using</span>
<span class="doccomment">/// parse_duration, but we can change some details of the exact composition</span>
<span class="doccomment">/// of the value.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use std::time::Duration;</span>
<span class="doccomment">/// use humantime::format_duration;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let val1 = Duration::new(9420, 0);</span>
<span class="doccomment">/// assert_eq!(format_duration(val1).to_string(), &quot;2h 37m&quot;);</span>
<span class="doccomment">/// let val2 = Duration::new(0, 32_000_000);</span>
<span class="doccomment">/// assert_eq!(format_duration(val2).to_string(), &quot;32ms&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">format_duration</span>(<span class="ident">val</span>: <span class="ident">Duration</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">FormattedDuration</span> {
    <span class="ident">FormattedDuration</span>(<span class="ident">val</span>)
}

<span class="kw">fn</span> <span class="ident">item_plural</span>(<span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span>, <span class="ident">started</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">bool</span>,
    <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">value</span>: <span class="ident">u64</span>)
    <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span>
{
    <span class="kw">if</span> <span class="ident">value</span> <span class="op">&gt;</span> <span class="number">0</span> {
        <span class="kw">if</span> <span class="kw-2">*</span><span class="ident">started</span> {
            <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot; &quot;</span>)<span class="question-mark">?</span>;
        }
        <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{}{}&quot;</span>, <span class="ident">value</span>, <span class="ident">name</span>)<span class="question-mark">?</span>;
        <span class="kw">if</span> <span class="ident">value</span> <span class="op">&gt;</span> <span class="number">1</span> {
            <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;s&quot;</span>)<span class="question-mark">?</span>;
        }
        <span class="kw-2">*</span><span class="ident">started</span> <span class="op">=</span> <span class="bool-val">true</span>;
    }
    <span class="prelude-val">Ok</span>(())
}
<span class="kw">fn</span> <span class="ident">item</span>(<span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span>, <span class="ident">started</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">bool</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>, <span class="ident">value</span>: <span class="ident">u32</span>)
    <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span>
{
    <span class="kw">if</span> <span class="ident">value</span> <span class="op">&gt;</span> <span class="number">0</span> {
        <span class="kw">if</span> <span class="kw-2">*</span><span class="ident">started</span> {
            <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot; &quot;</span>)<span class="question-mark">?</span>;
        }
        <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{}{}&quot;</span>, <span class="ident">value</span>, <span class="ident">name</span>)<span class="question-mark">?</span>;
        <span class="kw-2">*</span><span class="ident">started</span> <span class="op">=</span> <span class="bool-val">true</span>;
    }
    <span class="prelude-val">Ok</span>(())
}

<span class="kw">impl</span> <span class="ident">FormattedDuration</span> {
    <span class="doccomment">/// Returns a reference to the [`Duration`][] that is being formatted.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_ref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">Duration</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="number">0</span>
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">FormattedDuration</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="kw">let</span> <span class="ident">secs</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">as_secs</span>();
        <span class="kw">let</span> <span class="ident">nanos</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">subsec_nanos</span>();

        <span class="kw">if</span> <span class="ident">secs</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> <span class="ident">nanos</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
            <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="string">&quot;0s&quot;</span>)<span class="question-mark">?</span>;
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
        }

        <span class="kw">let</span> <span class="ident">years</span> <span class="op">=</span> <span class="ident">secs</span> <span class="op">/</span> <span class="number">31_557_600</span>;  <span class="comment">// 365.25d</span>
        <span class="kw">let</span> <span class="ident">ydays</span> <span class="op">=</span> <span class="ident">secs</span> <span class="op">%</span> <span class="number">31_557_600</span>;
        <span class="kw">let</span> <span class="ident">months</span> <span class="op">=</span> <span class="ident">ydays</span> <span class="op">/</span> <span class="number">2_630_016</span>;  <span class="comment">// 30.44d</span>
        <span class="kw">let</span> <span class="ident">mdays</span> <span class="op">=</span> <span class="ident">ydays</span> <span class="op">%</span> <span class="number">2_630_016</span>;
        <span class="kw">let</span> <span class="ident">days</span> <span class="op">=</span> <span class="ident">mdays</span> <span class="op">/</span> <span class="number">86400</span>;
        <span class="kw">let</span> <span class="ident">day_secs</span> <span class="op">=</span> <span class="ident">mdays</span> <span class="op">%</span> <span class="number">86400</span>;
        <span class="kw">let</span> <span class="ident">hours</span> <span class="op">=</span> <span class="ident">day_secs</span> <span class="op">/</span> <span class="number">3600</span>;
        <span class="kw">let</span> <span class="ident">minutes</span> <span class="op">=</span> <span class="ident">day_secs</span> <span class="op">%</span> <span class="number">3600</span> <span class="op">/</span> <span class="number">60</span>;
        <span class="kw">let</span> <span class="ident">seconds</span> <span class="op">=</span> <span class="ident">day_secs</span> <span class="op">%</span> <span class="number">60</span>;

        <span class="kw">let</span> <span class="ident">millis</span> <span class="op">=</span> <span class="ident">nanos</span> <span class="op">/</span> <span class="number">1_000_000</span>;
        <span class="kw">let</span> <span class="ident">micros</span> <span class="op">=</span> <span class="ident">nanos</span> <span class="op">/</span> <span class="number">1000</span> <span class="op">%</span> <span class="number">1000</span>;
        <span class="kw">let</span> <span class="ident">nanosec</span> <span class="op">=</span> <span class="ident">nanos</span> <span class="op">%</span> <span class="number">1000</span>;

        <span class="kw">let</span> <span class="kw-2">ref</span> <span class="kw-2">mut</span> <span class="ident">started</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="ident">item_plural</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;year&quot;</span>, <span class="ident">years</span>)<span class="question-mark">?</span>;
        <span class="ident">item_plural</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;month&quot;</span>, <span class="ident">months</span>)<span class="question-mark">?</span>;
        <span class="ident">item_plural</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;day&quot;</span>, <span class="ident">days</span>)<span class="question-mark">?</span>;
        <span class="ident">item</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;h&quot;</span>, <span class="ident">hours</span> <span class="kw">as</span> <span class="ident">u32</span>)<span class="question-mark">?</span>;
        <span class="ident">item</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;m&quot;</span>, <span class="ident">minutes</span> <span class="kw">as</span> <span class="ident">u32</span>)<span class="question-mark">?</span>;
        <span class="ident">item</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;s&quot;</span>, <span class="ident">seconds</span> <span class="kw">as</span> <span class="ident">u32</span>)<span class="question-mark">?</span>;
        <span class="ident">item</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;ms&quot;</span>, <span class="ident">millis</span>)<span class="question-mark">?</span>;
        <span class="ident">item</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;us&quot;</span>, <span class="ident">micros</span>)<span class="question-mark">?</span>;
        <span class="ident">item</span>(<span class="ident">f</span>, <span class="ident">started</span>, <span class="string">&quot;ns&quot;</span>, <span class="ident">nanosec</span>)<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="ident">std::time::Duration</span>;

    <span class="kw">use</span> <span class="ident">rand::Rng</span>;

    <span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">parse_duration</span>, <span class="ident">format_duration</span>};
    <span class="kw">use</span> <span class="ident"><span class="kw">super</span>::Error</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::cognitive_complexity</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_units</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;17nsec&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">17</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;17nanos&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">17</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;33ns&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">33</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;3usec&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">3000</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;78us&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">78000</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;31msec&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">31_000_000</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;31millis&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">31_000_000</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;6ms&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">0</span>, <span class="number">6_000_000</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;3000s&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">3000</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;300sec&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">300</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;300secs&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">300</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;50seconds&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">50</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1second&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">1</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;100m&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">6000</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;12min&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">720</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;12mins&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">720</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1minute&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">60</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;7minutes&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">420</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;2h&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">7200</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;7hr&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">25200</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;7hrs&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">25200</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1hour&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">3600</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;24hours&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">86400</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1day&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">86400</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;2days&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">172_800</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;365d&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">31_536_000</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1week&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">604_800</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;7weeks&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">4_233_600</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;52w&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">31_449_600</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1month&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">2_630_016</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;3months&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">3</span><span class="kw-2">*</span><span class="number">2_630_016</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;12M&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">31_560_192</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1year&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">31_557_600</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;7years&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">7</span><span class="kw-2">*</span><span class="number">31_557_600</span>, <span class="number">0</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;17y&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">536_479_200</span>, <span class="number">0</span>)));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_combo</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;20 min 17 nsec &quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">1200</span>, <span class="number">17</span>)));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;2h 15m&quot;</span>), <span class="prelude-val">Ok</span>(<span class="ident">Duration::new</span>(<span class="number">8100</span>, <span class="number">0</span>)));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">all_86400_seconds</span>() {
        <span class="kw">for</span> <span class="ident">second</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">86400</span> {  <span class="comment">// scan leap year and non-leap year</span>
            <span class="kw">let</span> <span class="ident">d</span> <span class="op">=</span> <span class="ident">Duration::new</span>(<span class="ident">second</span>, <span class="number">0</span>);
            <span class="macro">assert_eq!</span>(<span class="ident">d</span>,
                <span class="ident">parse_duration</span>(<span class="kw-2">&amp;</span><span class="ident">format_duration</span>(<span class="ident">d</span>).<span class="ident">to_string</span>()).<span class="ident">unwrap</span>());
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">random_second</span>() {
        <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">10000</span> {
            <span class="kw">let</span> <span class="ident">sec</span> <span class="op">=</span> <span class="ident">rand::thread_rng</span>().<span class="ident">gen_range</span>(<span class="number">0</span>, <span class="number">253_370_764_800</span>);
            <span class="kw">let</span> <span class="ident">d</span> <span class="op">=</span> <span class="ident">Duration::new</span>(<span class="ident">sec</span>, <span class="number">0</span>);
            <span class="macro">assert_eq!</span>(<span class="ident">d</span>,
                <span class="ident">parse_duration</span>(<span class="kw-2">&amp;</span><span class="ident">format_duration</span>(<span class="ident">d</span>).<span class="ident">to_string</span>()).<span class="ident">unwrap</span>());
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">random_any</span>() {
        <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">10000</span> {
            <span class="kw">let</span> <span class="ident">sec</span> <span class="op">=</span> <span class="ident">rand::thread_rng</span>().<span class="ident">gen_range</span>(<span class="number">0</span>, <span class="number">253_370_764_800</span>);
            <span class="kw">let</span> <span class="ident">nanos</span> <span class="op">=</span> <span class="ident">rand::thread_rng</span>().<span class="ident">gen_range</span>(<span class="number">0</span>, <span class="number">1_000_000_000</span>);
            <span class="kw">let</span> <span class="ident">d</span> <span class="op">=</span> <span class="ident">Duration::new</span>(<span class="ident">sec</span>, <span class="ident">nanos</span>);
            <span class="macro">assert_eq!</span>(<span class="ident">d</span>,
                <span class="ident">parse_duration</span>(<span class="kw-2">&amp;</span><span class="ident">format_duration</span>(<span class="ident">d</span>).<span class="ident">to_string</span>()).<span class="ident">unwrap</span>());
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_overlow</span>() {
        <span class="comment">// Overflow on subseconds is earlier because of how we do conversion</span>
        <span class="comment">// we could fix it, but I don&#39;t see any good reason for this</span>
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;100000000000000000000ns&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;100000000000000000us&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;100000000000000ms&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));

        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;100000000000000000000s&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;10000000000000000000m&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1000000000000000000h&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;100000000000000000d&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;10000000000000000w&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;1000000000000000M&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;10000000000000y&quot;</span>),
            <span class="prelude-val">Err</span>(<span class="ident">Error::NumberOverflow</span>));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_nice_error_message</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;123&quot;</span>).<span class="ident">unwrap_err</span>().<span class="ident">to_string</span>(),
            <span class="string">&quot;time unit needed, for example 123sec or 123ms&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;10 months 1&quot;</span>).<span class="ident">unwrap_err</span>().<span class="ident">to_string</span>(),
            <span class="string">&quot;time unit needed, for example 1sec or 1ms&quot;</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">parse_duration</span>(<span class="string">&quot;10nights&quot;</span>).<span class="ident">unwrap_err</span>().<span class="ident">to_string</span>(),
            <span class="string">&quot;unknown time unit \&quot;nights\&quot;, supported units: \
            ns, us, ms, sec, min, hours, days, weeks, months, \
            years (and few variations)&quot;</span>);
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="humantime" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>